﻿# fuelle-greedy-rekursiv.py
# Programm zum Füllen eines Containers mit greedy
# Problem der Rekursionstiefe beachten!

# Globale Variable für die Stücke:
stuecke=[30,30,30,20,20,20,20]

# Prädikat zum Testen, ob der Container voll ist.
def istVoll(container, fassungsvermoegen):
    return fassungsvermoegen==sum(container)

def istZuVoll(container, fassungsvermoegen):
    return fassungsvermoegen<sum(container)

def fuelle(stuecke, container, fassungsvermoegen):
    if istVoll(container, fassungsvermoegen):
        return container
    elif len(stuecke)==0:
        return False
    elif istZuVoll(stuecke[:1]+container, fassungsvermoegen):
        return fuelle(stuecke[1:], container, fassungsvermoegen)
    else:
        return fuelle(stuecke[1:], container+stuecke[:1], fassungsvermoegen)
    
print( 'Ergebnis: ', fuelle(stuecke, [], 80) )
print( 'Ergebnis: ', fuelle(stuecke, [], 90) )
print( 'Ergebnis: ', fuelle(stuecke, [], 100) )
