﻿# fuelle-greedy.py
# Programm zum Füllen eines Containers mit greedy
# Obwohl es bei der kleinen Rekursionstiefe nicht zwingend ist,
# sollte bei Python mit einer Schleife gearbeitet werden.

# Globale Variable für die Stücke:
stuecke=[30,30,30,20,20,20,20]

# Prädikat zum Testen, ob der Container voll ist.
def istVoll(container, fassungsvermoegen):
    return fassungsvermoegen==sum(container)

def istZuVoll(container, fassungsvermoegen):
    return fassungsvermoegen<sum(container)


def fuelle(stuecke, container, fassungsvermoegen):
    while len(stuecke)!=0:
        container.append(stuecke[0])
        stuecke=stuecke[1:]
        if istVoll(container, fassungsvermoegen):
            return container
        elif istZuVoll(container, fassungsvermoegen):
            container=container[:len(container)-1]
    return False
    
print( fuelle(stuecke, [], 80) )
print( fuelle(stuecke, [], 90) )
print( fuelle(stuecke, [], 100) )
